package com.ruoyi.framework.aspect;

import com.baomidou.mybatisplus.core.toolkit.ObjectUtils;
import com.ruoyi.common.annotation.LogicIgnore;
import com.ruoyi.framework.mybatis.holder.LogicHolder;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.stereotype.Component;

/**
 * 逻辑删除切面
 */
@Aspect
@Component
public class LogicAspect {

    /**
     * 去除逻辑删除
     * @param point
     * @param logicIgnore
     * @return
     * @throws Throwable
     */
    @Around("@annotation(logicIgnore) || @within(logicIgnore)")
    public Object around(ProceedingJoinPoint point, LogicIgnore logicIgnore) throws Throwable {
        try {
            //TODO 这里通过切面进来logicIgnore 一直是null  问题待排查......
            if(ObjectUtils.isNotEmpty(logicIgnore)){
                String[] alias = logicIgnore.alias();
                String[] tableName = logicIgnore.tableName();
                LogicHolder logicHolder = new LogicHolder();
                logicHolder.setAliases(alias);
                logicHolder.setTableNames(tableName);
                // 开启忽略
                LogicHolder.setLogicHolder(logicHolder);
            }else{
                String[] alias = {};
                String[] tableName = {};
                LogicHolder logicHolder = new LogicHolder();
                logicHolder.setAliases(alias);
                logicHolder.setTableNames(tableName);
                // 开启忽略
                LogicHolder.setLogicHolder(logicHolder);
            }

            // 执行方法
            return point.proceed();

        } finally {
            // 关闭忽略
            LogicHolder.clear();
        }
    }

}
